<script>
import Cti from '../assets/cti'

function btnCtiLogin() {

  try
  {
    Cti.clearHandlers();
  }
  catch(e)
  {
    console.warn('Warn : Handlers unclearable:');
  }

  const FormFQDN = document.getElementById("FQDN").value

  login(FormFQDN)
  .then((data) => {openWebsocket(data.token, FormFQDN);})
  .catch(error => console.error('Error loginCti:', error));

}

function openWebsocket(token, FQDN) {

  console.log("token : "+token);
  var wsurl = "wss://"+FQDN+"/xuc/api/2.0/cti?token="+token;
  Cti.WebSocket.init(wsurl,"jbond","1234");

  setHandler();

  return 0
}

function loggedOnHandler() {
    Cti.getConfig('line');
    Cti.getIceConfig();
}

function iceconfigHandler(iceConfig) {
  let turn = iceConfig.turnConfig
  console.log("turn url : " , iceConfig.turnConfig);
  let turURL = turn.urls[0].split(':')[1]
  let credential = turn.credential
  let username = turn.username
  redirectTestPage(encodeURIComponent(turURL), encodeURIComponent(credential), encodeURIComponent(username))
}

function setHandler() {
  Cti.setHandler(Cti.MessageType.LOGGEDON, loggedOnHandler);
  Cti.setHandler(Cti.MessageType.ICECONFIG, iceconfigHandler); 
}

async function redirectTestPage(turnURL, credentials, username) {
  console.log(`URL turn : ${turnURL}`)
  console.log(`Credentials turn : ${credentials}`)
  console.log(`Username turn : ${username}`)

  const uri = `/checkEdge/index.html?turnURI=${ turnURL }&turnUsername=${ username }&turnCredential=${ credentials }`;

  console.log(uri)

  Cti.clearHandlers();
  window.location.href = uri;
}

async function login(FQDN) {

  const username = document.getElementById("username").value
  const password = document.getElementById("password").value

  const url = 'https://'+FQDN+'/xuc/api/2.0/auth/login';
  const data = {
    login: username,
    password: password,
  };

  const response = await fetch(url, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    body: JSON.stringify(data),
  });

  if (!response.ok) {
    throw new Error(`HTTP error! Status: ${response.status}`);
  }

  const responseData = await response.json();

  return responseData;
}


export default {
  name: 'HelloWorld',
  props: {
    msg: String
  },
  methods: {
    btnCtiLogin : btnCtiLogin
  },
  data() {
    return {
      formUsername: "",
      formPassword: "",
      formFQDN: ""
    };
  },
}
</script>

<template>
<div class="border-solid border-1 border-gray-200 w-[50%] h-[50%] mx-auto my-4 gap-40">


  <label class="self-center gap-4 p-3 mx-4 my-auto bg-white">Login Cti</label>

  <div class="block" autocomplete="on">
    <input id="FQDN" class="m-2 border-b-2 border-orange-500 focus:border-b-4 focus:outline-none" 
    type="text" placeholder="URL Xivo" v-model="formFQDN" value=${EDGE_FQDN}/>
    <input id="username" class="m-2 border-b-2 border-orange-500 focus:border-b-4 focus:outline-none" 
    type="text" placeholder="Username" v-model="formUsername" autofocus/>
    <input id="password" class="m-2 border-b-2 border-orange-500 focus:border-b-4 focus:outline-none" 
    type="password" placeholder="Password" v-model="formPassword"/>     <br>
    <button id="LoginCtiButton" class="px-20 align-middle bg-gray-400 w-fit h-fit" @click="btnCtiLogin();">Login</button>
  </div>



</div>
</template>
